/*

  Copyright (C) 2001 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.aspects.authentication;

/**
 * This class implements a user that can be used by the owning and the
 * authentication aspects.<p>
 */

public class User implements java.io.Serializable {

   String name = "";

   /**
    * Creates a new user with a given name.
    *
    * @param name the given name */

   public User ( String name ) {
      this.name = name;
   }

   /**
    * Get the name of the current user.
    *
    * @return the name */

   public String getName() {
      return name;
   }

   /**
    * Set the name of the current user.
    *
    * @param name the new name */
   
   public void setName(String name) {
      this.name=name;
   }
   
   /**
    * Tells if two users are equals. The comparison is done on the
    * names.
    *
    * @param o the user to check */

   public boolean equals ( Object o ) {
      User u = (User)o;
      if ( name == null ) return false;
      return u.name.equals( name );
   }
}







