/*

  Copyright (C) 2001 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package jac.aspects.gui;

import jac.core.*;

/**
 * This wrapper is used by the GUI aspect to notify the administration
 * GUI (<code>ProgramView</code>) when some configuration events
 * happens within the JAC system.
 *
 * @see ProgramView */

public class AdminWrapper extends Wrapper {

   /**
    * This wrapping method wraps the application's registration method
    * so that the administration GUI is notified when a new program is
    * created in the system. */

   public Object whenNewProgram() {
      Object ret = null; 
      ret = proceed();
      ProgramView.get().setProgram( 
         ((Application)this.arg(0)).getName() );
      return ret;
   }

   /**
    * This wrapping method wraps the aspect configuration's
    * registration method so that the administration GUI is notified
    * when a new aspect if configured in the system. */
    
   public Object whenNewConfiguration() {
      return proceed();
   }
}
