/*

  Copyright (C) 2001 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package jac.aspects.gui;

import java.text.*;
import java.util.*;
import javax.swing.*;
import java.awt.Component;

/**
 * A Swing editor component for boolean values.
 */

public class BooleanEditor extends JPanel implements ValueEditor {
   
   JCheckBox checkBox;

   /**
    * Constructs a new primitive checkbox editor for booleans. */

   public BooleanEditor() {
      add( checkBox = new JCheckBox() );
  }

   /**
    * Gets the value of the edited booelan.
    *
    * @return a <code>Boolean</code> instance */
 
   public Object getValue() {
      return new Boolean( checkBox.isSelected() );
   }

   /**
    * Sets the value of the edited boolean.
    *
    * @param value a <code>Boolean</code> instance */

   public void setValue(Object value) {
      checkBox.setSelected( ((Boolean)value).booleanValue() );
   }

   /**
    * Set the focus on the checkBox
    */
   public void requestFocus() {
      checkBox.requestFocus();
      jac.util.Log.trace("gui.focus","focusing "+checkBox.getClass().getName());
   }

   public void setWidth(int width) {}

   public void setHeight(int height) {}

   public Component getValueComponent() {
      return checkBox;
   }

   public void onSetFocus(Object extraOption) {}
   
}

