/*

  Copyright (C) 2001 Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package jac.aspects.gui;

/**
 * HTML editor for booleans.
 */
public class HTMLBooleanEditor extends AbstractHTMLEditor implements HTMLEditor 
{
   public HTMLBooleanEditor() {
   }

   public String genHTML(String name) 
   {
      String html = "<SELECT NAME="+name+">\n";
      if(value.equals(Boolean.TRUE)) {
         html += "<OPTION VALUE=true selected>true</OPTION>";
         html += "<OPTION VALUE=false>false</OPTION>";
      } else {
         html += "<OPTION VALUE=false selected>false</OPTION>";
         html += "<OPTION VALUE=true>true</OPTION>";
      }
      html += "</SELECT>\n";
      return html;
   }

   public Object getValue(String string) {
      return new Boolean(string);
   }
}
