/*

  Copyright (C) 2001 Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package jac.aspects.gui;

import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.Date;

/**
 * HTML editor and viewer for dates.
 *
 * @see GuiConf#setDateFormat(String)
 * @see java.util.Date
 */
public class HTMLDateEditor  extends AbstractHTMLEditor implements HTMLEditor, HTMLViewer
{
   SimpleDateFormat format = new SimpleDateFormat(GuiAC.getDateFormat());
   public HTMLDateEditor() {
   }

   public String genHTML(String name) {
      return "<input type=text name=\""+name+"\" "+
         "value=\""+(value!=null?format.format((Date)value):"")+"\">\n";
   }

   public String genHTML(Object value, boolean isSmall) {
      return format.format((Date)value);
   }

   public Object getValue(String string) {
      try {
         if (string.length()==0)
            return null;
         else
            return format.parse(string);
      } catch(ParseException e) {
         throw new Error(e.toString());
      }
   }

}

