/*

  Copyright (C) 2001 Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.aspects.gui;

/**
 * This interface defines an editor used by the WebGUI. It has methods
 * to generate HTML code.
 *
 * @see HTMLViewer
 */

public interface HTMLEditor {
   /**
    * Generate the HTML code for the editor.
    *
    * @param value the default value to display
    * @param name the name of the HTML element
    *
    * @return the HTML code. */

   String genHTML(String name);

   /**
    * Set the value to edit.
    * @param value the value to edit.
    */
   void setValue(Object value);

   /**
    * Set the type of the value to edit.
    * @param type the type of the value to edit.
    */
   void setType(Class type);

   /**
    * Convert a string to an object.
    */
   
   Object getValue(String string);
}
