/*

  Copyright (C) 2001 Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA */

package jac.aspects.gui;

/**
 * An HTML viewer for URL which are images.
 */
public class HTMLImageURLViewer implements HTMLViewer 
{
   boolean small = false;

   public String genHTML(Object value, boolean isSmall) 
   {
      if (!value.toString().equals("file:")) {
         if (!isSmall) {
            return  "<IMG SRC=\""+value+"\" alt=\"image\">";
         } else {
            return "<IMG SRC=\""+value+"\" width=50 height=50 "+
               "alt=\"image\">";
         }
      } else {
         return "";
      }
   }
}
