/*

  Copyright (C) 2001 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.aspects.gui;

import java.net.URL;
import java.awt.event.*;
import java.awt.Component;
import javax.swing.*;

/**
 * This is a special value editor that allows the user to nicely edit
 * an URL. */

public class ImageURLEditor extends JPanel implements ValueEditor {

   protected JLabel image;
   protected URLEditor urlEditor;

   /**
    * Constructs a new URL editor.
    */

   public ImageURLEditor() {
      image = new JLabel();
      urlEditor = new URLEditor();
      setLayout( new BoxLayout( this, BoxLayout.Y_AXIS ) );
      add(image);
      add(urlEditor);
   }

   public void setValue(Object value) {
      urlEditor.setValue(value);
      image.setIcon(value != null ? new ImageIcon((URL)value) : null);
   }

   public Object getValue() {
      return urlEditor.getValue();
   }

   public void setWidth(int width) {
      urlEditor.setWidth(width);
   }

   public void setHeight(int height) {
      urlEditor.setHeight(height);
   }

   public Component getValueComponent() {
      return urlEditor.getValueComponent();
   }

   public void onSetFocus(Object extra) {
      urlEditor.onSetFocus(extra);
   }
}
