/*

  Copyright (C) 2001 Laurent Martelli.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.aspects.persistence;

import jac.util.*;

/**
 * An implementation of OID with a long
 *
 */

public class LongOID extends OID {
   private long oid = 0;
   public LongOID(long oid) {
      this.oid = oid;
   }
   public long getOID() {
      return oid;
   }
   public boolean equals(Object obj) {
      return (obj instanceof LongOID)
         && (oid == ((LongOID)obj).getOID());
   }
   public String toString() {
      return new Long(oid).toString();
   }   
   public int hashCode() {
      return new Long(oid).intValue();
   }
}
