/*
  Copyright (C) 2001 Laurent Martelli.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.aspects.persistence;

/**
 * Abstract class that defines an object identifier. It should be
 * subclassed by <code>Storage</code> implementors.
 *
 * <strong>Note that you should also define the <code>hashCode</code>
 * method.</em> 
 */

public abstract class OID implements java.io.Serializable {
   /**
    * Test if two OIDs are equal.
    * @param obj the OID to test
    * @return true if obj equals this OID
    */
   public abstract boolean equals(Object obj);
}
