package jac.core.parsers.acc;

import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.FileReader;
import java.util.Vector;

import jac.core.InputStreamParser;
import jac.util.Log;


public class AccParserWrapper implements InputStreamParser 
{
   public AccParserWrapper() {
   }

   public Vector parse(InputStream inputStream, String streamName, 
                       String targetClass) 
   {
      AccScanner lexer = new AccScanner(new InputStreamReader(inputStream), 
                                        streamName);
      AccParser parser = new AccParser(lexer);
      // Parse the input expression
      Log.trace("parser","Parsing "+streamName+" ...");
      Vector methods = null;
      try {
         methods = (Vector)parser.parse().value;
            //          System.out.println(methods);
      } catch (Exception e) {
         lexer.printState();
         Log.error("Parser error in "+streamName+" : "+e);
         //         e.printStackTrace();
      }
      Log.trace("parser",streamName+" parsed");
      return methods;
   }

   public static void main(String[] args) 
   {
      AccScanner scanner = null;
      try {
         scanner = new AccScanner(new FileReader(args[0]),args[0]);
         AccParser myParser = new AccParser(scanner);
         Vector methods = (Vector)myParser.parse().value;
         System.out.println("Methods = "+methods);
      } catch (Exception e) {
         System.err.println(args[0]+":"+scanner.getLine());
         e.printStackTrace();
      }
   }
}
