/*
  Copyright (C) 2001 Renaud Pawlak, Laurent Martelli
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */


package jac.core.rtti;

import java.util.*;
import java.lang.reflect.*;
import jac.util.*;
import gnu.regexp.*;

/**
 * This class defines a meta item that corresponds to the
 * <code>java.lang.reflect.Class</code> meta element.<p>
 *
 * @author Renaud Pawlak
 * @author Laurent Martelli
 * @version 0.8.1
 */

public class VirtualClassItem extends MetaItem {

   String name;

   /**
    * Default contructor to create a new virtual class item object.<p>
    *
    * @param delegate the <code>java.lang.reflect.Class</code> actual
    * meta item */

   public VirtualClassItem ( String name ) {
      this.name = name;
   }

   public String getName() {
      return name;
   }

   public String toString() {
      return "VirtualClassItem "+name;
   }
}



