
package jac.ide;

import jac.lib.java.util.Vector;

public class Application {

   public String toString() {
      if( name != null ) {
         return name;
      } else {
         return super.toString();
      }
   }

   String name;
   
   /**
    * Get the value of name.
    * @return value of name.
    */
   public String getName() {
      return name;
   }
   
   /**
    * Set the value of name.
    * @param v  Value to assign to name.
    */
   public void setName(String  v) {
      this.name = v;
   }
   
   String launchingCode;
   
   /**
    * Get the value of launchingCode.
    * @return value of launchingCode.
    */
   public String getLaunchingCode() {
      return launchingCode;
   }
   
   /**
    * Set the value of launchingCode.
    * @param v  Value to assign to launchingCode.
    */
   public void setLaunchingCode(String  v) {
      this.launchingCode = v;
   }
   
   Vector aspectConfigurations = new Vector();
   
   /**
    * Get the value of aspectConfigurations.
    * @return value of aspectConfigurations.
    */
   public Vector getAspectConfigurations() {
      return aspectConfigurations;
   }
   
   /**
    * Set the value of aspectConfigurations.
    * @param v  Value to assign to aspectConfigurations.
    */
   public void setAspectConfigurations(Vector  v) {
      this.aspectConfigurations = v;
   }
   
   public void addAspectConfiguration(AspectConfiguration a) {
      aspectConfigurations.add(a);
   }

   public void removeAspectConfiguration(AspectConfiguration a) {
      aspectConfigurations.remove(a);
   }

   Vector externalPaths = new Vector();
   
   /**
    * Get the value of externalPaths.
    * @return value of externalPaths.
    */
   public Vector getExternalPaths() {
      return externalPaths;
   }
   
   /**
    * Set the value of externalPaths.
    * @param v  Value to assign to externalPaths.
    */
   public void setExternalPaths(Vector  v) {
      this.externalPaths = v;
   }
   
   public void addExternalPath(String path) {
      externalPaths.add(path);
   }

   public void removeExternalPath(String path) {
      externalPaths.remove(path);
   }

   Project project;
   
   /**
    * Get the value of project.
    * @return value of project.
    */
   public Project getProject() {
      return project;
   }
   
   /**
    * Set the value of project.
    * @param v  Value to assign to project.
    */
   public void setProject(Project  v) {
      this.project = v;
   }
   
   Process currentProcess=null;

   public void start() {
      java.io.File wkdir = new java.io.File(getProject().getGenerationPath().getPath()+
                                            "/classes");
      String cmd = "jac ../"+name+"/"+name+".jac";
      System.out.println("CMD = "+cmd);
      System.out.println("launching application "+name+"...");
      try {
         stop();
         currentProcess = Runtime.getRuntime().exec(cmd,null,wkdir);
      } catch(Exception e) {
         e.printStackTrace();
      }
   }

   public void stop() {
      System.out.println("killing the subprocess");
      if(currentProcess!=null)
         currentProcess.destroy();
   }

}
