
package jac.ide;

import  jac.lib.java.util.Vector;
import  java.util.Iterator;

public class Class extends Type {

   Class superClass;
   
   /**
    * Get the value of superClass.
    * @return value of superClass.
    */
   public Class getSuperClass() {
      return superClass;
   }
   
   /**
    * Set the value of superClass.
    * @param v  Value to assign to superClass.
    */
   public void setSuperClass(Class  v) {
      this.superClass = v;
   }

   public Field findField(String name) {
      Iterator it = getFields().iterator();
      while(it.hasNext()) {
         Field f = (Field)it.next();
         if(f.getName().equals(name)) {
            return f;
         }
      }
      return null;
   }
   
   Vector fields=new Vector();
   
   /**
    * Get the value of fields.
    * @return value of fields.
    */
   public Vector getFields() {
      return fields;
   }
   
   /**
    * Set the value of fields.
    * @param v  Value to assign to fields.
    */
   public void setFields(Vector  v) {
      this.fields = v;
   }
   
   public void addField(Field f) {
      fields.add(f);
   }

   public void removeField(Field f) {
      fields.remove(f);
   }

   Vector methods=new Vector();
   
   /**
    * Get the value of methods.
    * @return value of methods.
    */
   public Vector getMethods() {
      return methods;
   }
   
   /**
    * Set the value of methods.
    * @param v  Value to assign to methods.
    */
   public void setMethods(Vector  v) {
      this.methods = v;
   }
   
   public void addMethod(Method m) {
      methods.add(m);
   }

   public void removeMethod(Method m) {
      fields.remove(m);
   }


   Vector relationLinks=new Vector();
   
   /**
    * Get the value of relationLinks.
    * @return value of relationLinks.
    */
   public Vector getRelationLinks() {
      return relationLinks;
   }
   
   /**
    * Set the value of relationLinks.
    * @param v  Value to assign to relationLinks.
    */
   public void setRelationLinks(Vector  v) {
      this.relationLinks = v;
   }
   
   public void addRelationLink(RelationLink rel) {
      relationLinks.add(rel);
      rel.setStart(this);
   }

   public void removeRelationLink(RelationLink rel) {
      relationLinks.remove(rel);
   }

   Package container;
   
   /**
    * Get the value of container.
    * @return value of container.
    */
   public Package getContainer() {
      return container;
   }
   
   /**
    * Set the value of container.
    * @param v  Value to assign to container.
    */
   public void setContainer(Package  v) {
      this.container = v;
   }

   public String getFullName() {
      if( container == null ) {
         return name;
      } else {
         return container.getPPath()+"."+name;
      }
   }
   
}
