package jac.ide;

import java.util.List;
import java.util.Map;
import java.util.Iterator;

import jac.aspects.gui.HandlerResult;

import jac.util.Log;

public class Errors {
   List errors;

   public Errors(List errors) {
      this.errors = errors;
   }

   public List getErrors() {
      return errors;
   }

   /*
    * GUI methods
    */

   
   public static HandlerResult selectionHandler(
      jac.aspects.gui.CustomizedGUI gui,
      jac.core.rtti.CollectionItem collection,
      Error error)
   {
      
      Class cl = error.getCl();
      Map lineNumbers = CodeGeneration.getClassLineNumbers(cl);
      Method method = null;
      Iterator i = lineNumbers.entrySet().iterator();
      int closestLine = 0;
      while(i.hasNext()) {
         Map.Entry entry = (Map.Entry)i.next();
         int line = ((Integer)entry.getValue()).intValue();
         Log.trace("ide.compile",line+" -> "+entry.getKey());
         if (error.getLine() > line && line > closestLine ) {
            closestLine = line;
            Log.trace("ide.compile","closestLine = "+closestLine);
            method = (Method)entry.getKey();
         }
      }
      return new HandlerResult(
         jac.core.rtti.ClassRepository.get()
         .getClass(jac.ide.Class.class).getField("methods"),
         method,"body",new Integer(error.getLine()-closestLine));
   }
}
