
package jac.ide;

import jac.lib.java.util.Vector;
import java.util.Iterator;

public class Package extends ModelElement {

   Package parent;
   
   /**
    * Get the value of parent.
    * @return value of parent.
    */
   public Package getParent() {
      return parent;
   }
   
   /**
    * Set the value of parent.
    * @param v  Value to assign to parent.
    */
   public void setParent(Package  v) {
      this.parent = v;
   }

   public String getPath() {
      if( parent == null ) {
         return name;
      } else {
         return parent.getPath()+"/"+name;
      }
   }

   public String getPPath() {
      if( parent == null ) {
         return name;
      } else {
         return parent.getPath()+"."+name;
      }
   }
   
   Vector subPackages=new Vector();
   
   /**
    * Get the value of packages.
    * @return value of packages.
    */
   public Vector getSubPackages() {
      return subPackages;
   }
   
   /**
    * Set the value of packages.
    * @param v  Value to assign to packages.
    */
   public void setSubPackages(Vector  v) {
      this.subPackages = v;
   }
   
   public void addSubPackage(Package p) {
      subPackages.add(p);
      p.setParent(this); 
   }
   
   public void removeSubPackage(Package p) {
      subPackages.remove(p);
   }

   Vector diagrams=new Vector();
   
   /**
    * Get the value of diagrams.
    * @return value of diagrams.
    */
   public Vector getDiagrams() {
      return diagrams;
   }
   
   /**
    * Set the value of diagrams.
    * @param v  Value to assign to diagrams.
    */
   public void setDiagrams(Vector  v) {
      this.diagrams = v;
   }
   
   public void addDiagram(Diagram d) {
      diagrams.add(d);
      d.setContainer(this);
   }

   public void removeDiagram(Diagram d) {
      diagrams.remove(d);
   }

   Vector classes=new Vector();

   public Class findClass(String name) {
      Iterator it = getClasses().iterator();
      while(it.hasNext()) {
         Class c = (Class)it.next();
         if(c.getName().equals(name)) {
            return c;
         }
      }
      return null;
   }
   
   /**
    * Get the value of classes.
    * @return value of classes.
    */
   public Vector getClasses() {
      return classes;
   }
   
   /**
    * Set the value of classes.
    * @param v  Value to assign to classes.
    */
   public void setClasses(Vector  v) {
      this.classes = v;
   }
   
   public void addClass(Class c) {
      classes.add(c);
      c.setContainer(this);
   }

   public void removeClass(Class c) {
      classes.remove(c);
   }

   Vector aspects;
   
   /**
    * Get the value of aspects.
    * @return value of aspects.
    */
   public Vector getAspects() {
      return aspects;
   }
   
   /**
    * Set the value of aspects.
    * @param v  Value to assign to aspects.
    */
   public void setAspects(Vector  v) {
      this.aspects = v;
   }
   
   public void addAspect(Aspect a) {
      aspects.add(a);
      a.setContainer(this);
   }

   public void removeAspect(Aspect a) {
      aspects.remove(a);
   }

   Vector instances;
   
   /**
    * Get the value of instances.
    * @return value of instances.
    */
   public Vector getInstances() {
      return instances;
   }
   
   /**
    * Set the value of instances.
    * @param v  Value to assign to instances.
    */
   public void setInstances(Vector  v) {
      this.instances = v;
   }
   
   public void addInstance(Instance i) {
      instances.add(i);
      i.setContainer(this);
   }

   public void removeInstance(Instance i) {
      instances.remove(i);
   }

   Vector groups;
   
   /**
    * Get the value of groups.
    * @return value of groups.
    */
   public Vector getGroups() {
      return groups;
   }
   
   /**
    * Set the value of groups.
    * @param v  Value to assign to groups.
    */
   public void setGroups(Vector  v) {
      this.groups = v;
   }
   
   public void addGroup(Group g) {
      this.groups.add(g);
      g.setContainer(this);
   }

   public void removeGroup(Group g) {
      this.groups.remove(g);
   }
      
}
