
package jac.ide;

import  jac.lib.java.util.Vector;
import  java.util.Iterator;

public class Projects {

   public static Projects root;
   public static TypeRepository types;

   public static void main(String[] args) {
      root = new Projects();
      types = new TypeRepository();

      // create the primitive types if needed

      if( types.getPrimitiveTypes().size() == 0 ) {
         types.addPrimitiveType(new Type("void"));
         types.addPrimitiveType(new Type("boolean"));
         types.addPrimitiveType(new Type("int"));
         types.addPrimitiveType(new Type("long"));
         types.addPrimitiveType(new Type("float"));
         types.addPrimitiveType(new Type("double"));
         types.addExternalClass(new Type("String"));
         Type type=new Type("Date");
         type.setPackagePath("java.util");
         types.addExternalClass(type);
      
         type = new Type("Vector");
         type.setPackagePath("jac.lib.java.util");
         types.addExternalClass(type);
      }


   }

   public static void generateCode() {
      Iterator it = root.projects.iterator();
      while(it.hasNext()) {
         Project p = (Project)it.next();
         p.generateCode();
      }
   }

   public static Errors compile() {
      Iterator it = root.projects.iterator();
      while(it.hasNext()) {
         Project p = (Project)it.next();
         Errors errors = p.compile();
         if(errors!=null) {
            return errors;
         }
      }
      return null;
   }

   public static void exit() {
      jac.aspects.gui.GuiAC.getDisplay("ide-gui").close();
      System.exit(0);
   }

   Vector projects=new Vector();
   
   /**
    * Get the value of projects.
    * @return value of projects.
    */
   public Vector getProjects() {
      return projects;
   }
   
   /**
    * Set the value of projects.
    * @param v  Value to assign to projects.
    */
   public void setProjects(Vector  v) {
      this.projects = v;
   }
   
   public void addProject(Project p) {
      projects.add(p);
   }
   
   public void removeProject(Project p) {
      projects.remove(p);
   }

   public String toString() {
      return "projects";
   }
}
