
package jac.ide;

import  jac.lib.java.util.Vector;
import jac.core.ObjectRepository;
import jac.core.rtti.ClassRepository;
import jac.core.rtti.NamingConventions;
import java.util.Collection;

public class RelationLink extends RoledLink {

   boolean aggregation;
   
   /**
    * Get the value of aggregation.
    * @return value of aggregation.
    */
   public boolean isAggregation() {
      return aggregation;
   }
   
   /**
    * Set the value of aggregation.
    * @param v  Value to assign to aggregation.
    */
   public void setAggregation(boolean  v) {
      this.aggregation = v;
   }
   
   public Type getEndType() {
      if(getEnd() == null) return null;
      if(isEndMultiple()) {
         return Projects.types.resolveType("Vector","jac.lib.java.util");
      } else {
         return (Type)getEnd();
      }
   }

   public Type getStartType() {
      if(getStart() == null) return null;
      if(isStartMultiple()) {
         return Projects.types.resolveType("Vector","jac.lib.java.util");
      } else {
         return (Type)getEnd();
      }
   }

   public boolean isEndMultiple() {
      if( getEndCardinality()!=null && (
         getEndCardinality().equals("*")||getEndCardinality().equals("0-*")||
         getEndCardinality().equals("1-*"))) {
         return true;
      } else {
         return false;
      }
   }

   public boolean isStartMultiple() {
      if( getStartCardinality()!=null && (
         getStartCardinality().equals("*")||getStartCardinality().equals("0-*")||
         getStartCardinality().equals("1-*"))) {
         return true;
      } else {
         return false;
      }
   }

   public String getEndPrototype() {
      if(getEnd()==null) return "<UNDEFINED END>";
      String role=NamingConventions.lowerFirst(getEnd().getName());
      if(getEndRole()!=null && !getEndRole().equals("")) {
         role=getEndRole();
      }
      String prototype=(getEndType().getFullName())+" "+role;
      if(isEndMultiple()) {
         return prototype+"=new "+getEndType().getFullName()+"()";
      } else {
         return prototype;
      }
   }

   public String getStartPrototype() {
      if(getStart()==null) return "<UNDEFINED START>";
      String role=NamingConventions.lowerFirst(getStart().getName());
      if(getStartRole()!=null && !getStartRole().equals("")) {
         role=getStartRole();
      }
      return (getStartType().getFullName())+" "+role;
   }

   public static Collection endChoices(Object substance) {
      return ObjectRepository.getObjects(ClassRepository.get().getClass(Class.class));
   }

}
