
package jac.ide;

import jac.lib.java.util.HashSet;
import java.util.Iterator;

public class TypeRepository {

   public static void show() {
      ((jac.aspects.gui.CustomizedGUI)jac.aspects.gui.GuiAC
       .getDisplay("type-repository-gui")).showAsSubDisplay();
   }

   public Type resolveType(String name) {
      return resolveType(name,"");
   }

   public Type resolveType(String name,String path) {
      Iterator it = primitiveTypes.iterator();
      while(it.hasNext()) {
         Type type = (Type)it.next();
         if(type.getName().equals(name)) {
            return type;
         }
      } 
      it = externalClasses.iterator();
      while(it.hasNext()) {
         Type type = (Type)it.next();
         if(path.equals("") && type.getName().equals(name)) {
            return type;
         } else if( path.equals(type.getPackagePath()) && 
                    type.getName().equals(name) ) {
            return type;
         }
      }
      return null;
   }

   HashSet primitiveTypes=new HashSet();
   
   /**
    * Get the value of primitiveTypes.
    * @return value of primitiveTypes.
    */
   public HashSet getPrimitiveTypes() {
      return primitiveTypes;
   }
   
   /**
    * Set the value of primitiveTypes.
    * @param v  Value to assign to primitiveTypes.
    */
   public void setPrimitiveTypes(HashSet  v) {
      this.primitiveTypes = v;
   }
   
   public void addPrimitiveType(Type t) {
      primitiveTypes.add(t);
   }

   HashSet externalClasses=new HashSet();
   
   /**
    * Get the value of externalClasses.
    * @return value of externalClasses.
    */
   public HashSet getExternalClasses() {
      return externalClasses;
   }
   
   /**
    * Set the value of externalClasses.
    * @param v  Value to assign to externalClasses.
    */
   public void setExternalClasses(HashSet  v) {
      this.externalClasses = v;
   }
   
   public void addExternalClass(jac.ide.Type c) {
      externalClasses.add(c);
   }

   public void removeExternalClass(jac.ide.Type c) {
      externalClasses.remove(c);
   }

}
