
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.framework.*;
import jac.ide.RelationLink;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

public class AttachedTextFigure extends TextFigure {

   public static int NAME = 0;
   public static int START_CARDINALITY = 1;
   public static int END_CARDINALITY = 2;
   public static int START_ROLE = 3;
   public static int END_ROLE = 4;

   public static AttachedTextFigure createName() {
      return new AttachedTextFigure(NAME);
   }

   public static AttachedTextFigure createStartCardinality() {
      return new AttachedTextFigure(START_CARDINALITY);
   }

   public static AttachedTextFigure createEndCardinality() {
      return new AttachedTextFigure(END_CARDINALITY);
   }

   public static AttachedTextFigure createStartRole() {
      return new AttachedTextFigure(START_ROLE);
   }

   public static AttachedTextFigure createEndRole() {
      return new AttachedTextFigure(END_ROLE);
   }

   public AttachedTextFigure() {}

   public AttachedTextFigure(int type) {
      this.type=type;
   }

   Object substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public Object getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(Object  v) {
      this.substance = v;
   }

   public void setText(String s) {
      super.setText(s);
      System.out.println("setText "+s+", type="+type);
      if( substance != null ) {
         if(type==NAME) {
            ((jac.ide.RoledLink)substance).setName(s);
         } else if(type==END_ROLE) {
            ((jac.ide.RoledLink)substance).setEndRole(s);
         } else if(type==END_CARDINALITY) {
            ((jac.ide.RoledLink)substance).setEndCardinality(s);
         } else if(type==START_ROLE) {
            ((jac.ide.RoledLink)substance).setStartRole(s);
         } else if(type==START_CARDINALITY) {
            ((jac.ide.RoledLink)substance).setStartCardinality(s);
         }
      }
   }

   public void refresh() {
      if( substance != null ) {
         if(type==NAME) {
            if(((jac.ide.RoledLink)substance).getName()!=null)
               super.setText(((jac.ide.RoledLink)substance).getName());
         } else if(type==END_ROLE) {
            if(((jac.ide.RoledLink)substance).getEndRole()!=null)
               super.setText(((jac.ide.RoledLink)substance).getEndRole());
         } else if(type==END_CARDINALITY) {
            if(((jac.ide.RoledLink)substance).getEndCardinality()!=null)
               super.setText(((jac.ide.RoledLink)substance).getEndCardinality());
         } else if(type==START_ROLE) {
            if(((jac.ide.RoledLink)substance).getStartRole()!=null)
               super.setText(((jac.ide.RoledLink)substance).getStartRole());
         } else if(type==START_CARDINALITY) {
            if(((jac.ide.RoledLink)substance).getStartCardinality()!=null)
               super.setText(((jac.ide.RoledLink)substance).getStartCardinality());
         }
      }
   }


   int type=-1;
   
   /**
    * Get the value of type.
    * @return value of type.
    */
   public int getType() {
      return type;
   }
   
   /**
    * Set the value of type.
    * @param v  Value to assign to type.
    */
   public void setType(int  v) {
      this.type = v;
   }
   

   //-- store / load ----------------------------------------------
   
   public void write(StorableOutput dw) {
      super.write(dw);
      
      dw.writeString(NameRepository.get().getName(substance));
      dw.writeInt(type);
      dw.writeStorable(connectedLink);
   }
   
   public void read(StorableInput dr) throws IOException {
      super.read(dr);
      
      try {
         String name = dr.readString();
         substance = NameRepository.get().getObject(name);
         type = dr.readInt();
         connect((Figure)dr.readStorable());
      } catch(Exception e) {
         e.printStackTrace();
      }
      
   }

   LinkFigure connectedLink;
   
   /**
    * Get the value of connectedLink.
    * @return value of connectedLink.
    */
   public LinkFigure getConnectedLink() {
      return connectedLink;
   }
   
   /**
    * Set the value of connectedLink.
    * @param v  Value to assign to connectedLink.
    */
   public void setConnectedLink(LinkFigure  v) {
      this.connectedLink = v;
   }
   

   public void connect(Figure f) {
      System.out.println("connecting text figure, type= "+type);
      super.connect(f);
      ((LinkFigure)f).addAttachedTextFigure(this);
      connectedLink=(LinkFigure)f;
   }

}
