
package jac.ide.diagrams;

import CH.ifa.draw.standard.*;
import CH.ifa.draw.framework.*;
import java.awt.*;

public class AttachedTextLocator extends AbstractLocator {
	public Point locate(Figure owner,Figure locatedObject) {
           System.out.println("locate text "+locatedObject);
           Point p = owner.center();
           Rectangle r = owner.displayBox();
           Rectangle r2 = locatedObject.displayBox();
           
           LinkFigure f = (LinkFigure)owner;

           if( f.endFigure()==null || f.startFigure()==null
               || locatedObject==null ) return p;

           AttachedTextFigure text = (AttachedTextFigure)locatedObject;

           if( text.getType()==AttachedTextFigure.END_ROLE ) { 

              System.out.println("locating end role");

              ChopBoxConnector chopper = new ChopBoxConnector(f.startFigure());
              
              Point ep = chopper.findEnd(f);

              double dY = (double)(ep.y - f.endFigure().center().y);
              double dX = (double)(ep.x - f.endFigure().center().x);
              double csquare = 400/(dY*dY+dX*dX);
              double dx = dX*Math.sqrt(csquare);
              double dy = dY*Math.sqrt(csquare);
              double tanAlpha = dy/dx;

              Point p1 = null;

              if( dY >= 0 ) {

                 p1 = new Point(
                    (int)(ep.x+dx-20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy+20*Math.cos(Math.atan(tanAlpha))) );
                 
              } else {

                 p1 = new Point(
                    (int)(ep.x+dx+20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy-20*Math.cos(Math.atan(tanAlpha))) );
              }

              return p1;
              /*
              if(r.getWidth()>r.getHeight()) {
                 return new Point(p.x, p.y-10); // hack
              } else {
                 return new Point((int)(p.x+(r2.getWidth())/2+5), p.y-10); // hack
                 }*/


           } else if( text.getType()==AttachedTextFigure.START_ROLE ) {

              System.out.println("locating start role");

              ChopBoxConnector chopper = new ChopBoxConnector(f.startFigure());
              
              Point ep = chopper.findStart(f);

              double dY = (double)-(ep.y - f.endFigure().center().y);
              double dX = (double)-(ep.x - f.endFigure().center().x);
              double csquare = 400/(dY*dY+dX*dX);
              double dx = dX*Math.sqrt(csquare);
              double dy = dY*Math.sqrt(csquare);
              double tanAlpha = dy/dx;

              Point p1 = null;

              if( dY > 0 ) {

                 p1 = new Point(
                    (int)(ep.x+dx+20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy-20*Math.cos(Math.atan(tanAlpha))) );
                 
              } else {

                 p1 = new Point(
                    (int)(ep.x+dx-20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy+20*Math.cos(Math.atan(tanAlpha))) );
              }

              return p1;
              /*
              if(r.getWidth()>r.getHeight()) {
                 return new Point(p.x, p.y-10); // hack
              } else {
                 return new Point((int)(p.x+(r2.getWidth())/2+5), p.y-10); // hack
                 }*/

           } else if( text.getType()==AttachedTextFigure.END_CARDINALITY ) { 
              
              System.out.println("locating end cardinality");
              
              ChopBoxConnector chopper = new ChopBoxConnector(f.startFigure());
              
              Point ep = chopper.findEnd(f);
              
              double dY = (double)(ep.y - f.endFigure().center().y);
              double dX = (double)(ep.x - f.endFigure().center().x);
              double csquare = 400/(dY*dY+dX*dX);
              double dx = dX*Math.sqrt(csquare);
              double dy = dY*Math.sqrt(csquare);
              double tanAlpha = dy/dx;
              
              Point p1 = null;
              
              if( dY >= 0 ) {
                 
                 p1 = new Point(
                    (int)(ep.x+dx+20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy-20*Math.cos(Math.atan(tanAlpha))) );
                 
              } else {
                 
                 p1 = new Point(
                    (int)(ep.x+dx-20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy+20*Math.cos(Math.atan(tanAlpha))) );
              }
              
              return p1;

           } else if( text.getType()==AttachedTextFigure.START_CARDINALITY ) { 
              
              System.out.println("locating start cardinality");

              ChopBoxConnector chopper = new ChopBoxConnector(f.startFigure());
              
              Point ep = chopper.findStart(f);

              double dY = (double)-(ep.y - f.endFigure().center().y);
              double dX = (double)-(ep.x - f.endFigure().center().x);
              double csquare = 400/(dY*dY+dX*dX);
              double dx = dX*Math.sqrt(csquare);
              double dy = dY*Math.sqrt(csquare);
              double tanAlpha = dy/dx;

              Point p1 = null;

              if( dY > 0 ) {

                 p1 = new Point(
                    (int)(ep.x+dx-20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy+20*Math.cos(Math.atan(tanAlpha))) );
                 
              } else {

                 p1 = new Point(
                    (int)(ep.x+dx+20*Math.sin(Math.atan(tanAlpha))), 
                    (int)(ep.y+dy-20*Math.cos(Math.atan(tanAlpha))) );
              }

              return p1;
              
           } else if ( text.getType()==AttachedTextFigure.NAME ) {

              if(r.getWidth()>r.getHeight()) {
                 return new Point(p.x, p.y+10); // hack
              } else {
                 return new Point((int)(p.x-(r2.getWidth()/2)-5), p.y-10); // hack
              }
           }
           return p;
	}
}


