
package jac.ide.diagrams;

import java.awt.*;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import jac.core.NameRepository;
import jac.core.Wrappee;
import jac.aspects.gui.View;
import jac.util.Log;

public class ClassFigure extends CompositeFigure 
   implements View {

   private static final int BORDER = 3;
   private Rectangle fDisplayBox;
   
   Vector relationLinkFigures = new Vector();
   Vector inheritanceLinkFigures = new Vector();
   Vector fieldFigures = new Vector();
   Vector methodFigures = new Vector();

   jac.ide.Class substance;
   
   // View interface
   public View getParentView() {
      return null;
   }

   public void refreshViewItem(jac.core.rtti.FieldItem field, 
                               jac.core.rtti.MethodItem method, Object[] args) {
      refreshView();
   }

   public void setFocus(jac.core.rtti.FieldItem field, Object extraOption) {}

   public void refreshView() {
      if( DiagramView.init ) return;
      DiagramView.init = true;
      initClass();
      layout();
      changed();
      DiagramView.refreshFigure(this);
      //editor().validate();
      DiagramView.init = false;
   }

   public void close() {}

   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public Object getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(jac.ide.Class  v) {
      this.substance = v;
   }
   
   /*
    * Serialization support.
    */
   private static final long serialVersionUID = -7877776240236946511L;
   private int pertFigureSerializedDataVersion = 1;
   
   public ClassFigure() {
      initialize();
   }

   /*   public void keyTyped(KeyEvent e) {
	System.out.println(e);
    }

    public void keyPressed(KeyEvent e) {
	System.out.println(e);
    }

    public void keyReleased(KeyEvent e) {
	System.out.println(e);
        }*/

   public void linkToClass(jac.ide.Diagram d) {
      jac.ide.Class c = d.getContainer().findClass(getName());
      if( c == null ) {
         c = new jac.ide.Class();
         c.setName(getName());
         d.getContainer().addClass(c);
      }
      substance = c;
      ((ClassNameFigure)figures().nextFigure()).setSubstance(c);
   }

   boolean isInternal() {
      return containerPackage.getClasses().contains(substance);
   }

   jac.ide.Package containerPackage;
   
   /**
    * Get the value of containerPackage.
    * @return value of containerPackage.
    */
   public jac.ide.Package getContainerPackage() {
      return containerPackage;
   }
   
   /**
    * Set the value of containerPackage.
    * @param v  Value to assign to containerPackage.
    */
   public void setContainerPackage(jac.ide.Package  v) {
      this.containerPackage = v;
   }
      
   void initClass() {
      if( substance == null ) {
         System.out.println("UNRESOLVED CLASS!");
      } else {
         Log.trace("figures","init class "+substance);
         removeAllMembers();
         initTitle();
         initFields();
         initMethods();
         ((Wrappee)substance).invokeRoleMethod("addView",new Object[]{this});
      }
   }

   void initTitle() {
      ClassNameFigure nf = (ClassNameFigure)figures().nextFigure(); 
      nf.setSubstance(substance);
      nf.setText(substance.getName());
   }

   void initFields() {
      Iterator it = substance.getFields().iterator();
      while(it.hasNext()) {
         jac.ide.Field f = (jac.ide.Field)it.next();
         ((Wrappee)f).invokeRoleMethod("addView",new Object[]{this});
         FieldFigure fieldFigure = new FieldFigure();
         Log.trace("figures","adding field "+f);
         add(fieldFigure);
         fieldFigures.add(fieldFigure);
         fieldFigure.setSubstance(f);
         fieldFigure.setText(f.toString());
      }
   }

   void initMethods() {
      Iterator it = substance.getMethods().iterator();
      while(it.hasNext()) {
         jac.ide.Method m = (jac.ide.Method)it.next();
         ((Wrappee)m).invokeRoleMethod("addView",new Object[]{this});
         MethodFigure methodFigure = new MethodFigure();
         Log.trace("figures","adding method "+m);
         add(methodFigure);
         methodFigures.add(methodFigure);
         methodFigure.setSubstance(m);
         methodFigure.setText(m.toString());
      }
   }

   void removeAllMembers() {
      FigureEnumeration it = figures();
      // skip the title
      it.nextFigure();
      while (it.hasMoreElements()) {
         Figure f = it.nextFigure();
         Log.trace("figures","removing "+f);
         remove(f);
      }
      methodFigures.clear();
      fieldFigures.clear();
   }

   protected void basicMoveBy(int x, int y) {
      fDisplayBox.translate(x, y);
      super.basicMoveBy(x, y);
   } 

   public Rectangle displayBox() {
      return new Rectangle(
         fDisplayBox.x,
         fDisplayBox.y,
         fDisplayBox.width,
         fDisplayBox.height);
   }

   public void basicDisplayBox(Point origin, Point corner) {
      fDisplayBox = new Rectangle(origin);
      fDisplayBox.add(corner);
      layout();
   }

   protected void drawBorder(Graphics g) {
      
      Rectangle r = displayBox();
      
      if( isInternal() ) {
         g.setColor(Color.white);
      } else {
         g.setColor(Color.lightGray);
      }
      g.fillRect(r.x, r.y, r.width, r.height);
      
      g.setColor(Color.black);
      
      g.drawRect(r.x, r.y, r.width, r.height);
      
      
      Figure f = figureAt(0);
      Rectangle rf = f.displayBox();
      
      g.drawLine(r.x,r.y+rf.height+1,r.x+r.width,r.y+rf.height+1);
      
      if( fieldFigures.size() > 0 ) {
         f = (Figure) fieldFigures.get(0);
         rf = f.displayBox();
         g.drawLine(r.x,rf.y,r.x+r.width,rf.y);
      }
      
   }

   public void draw(Graphics g) {
      drawBorder(g);
      super.draw(g);
   }

   public Vector handles() {
      Vector handles = new Vector();
      handles.addElement(new NullHandle(this, RelativeLocator.northWest()));
      handles.addElement(new NullHandle(this, RelativeLocator.northEast()));
      handles.addElement(new NullHandle(this, RelativeLocator.southWest()));
      handles.addElement(new NullHandle(this, RelativeLocator.southEast()));
      return handles;
   }

   void addRelationLinkFigure(RelationLinkFigure a) {
      relationLinkFigures.add(a);
   }

   void addInheritanceLinkFigure(InheritanceLinkFigure link) {
      inheritanceLinkFigures.add(link);
   }

   void removeInheritanceLinkFigure(InheritanceLinkFigure link) {
      inheritanceLinkFigures.remove(link);
   }

   void removeRelationLinkFigure(RelationLinkFigure a) {
      relationLinkFigures.remove(a);
   }

   public Vector getRelationLinkFigures() {
      return relationLinkFigures;
   }

   void addFieldFigure() {
      jac.ide.Field f = new jac.ide.Field();
      f.setName("newField");
      f.setType(jac.ide.Projects.types.resolveType("void"));
      substance.addField(f); 
   }

   void addMethodFigure() {
      jac.ide.Method m = new jac.ide.Method();
      m.setName("newMethod");
      m.setType(jac.ide.Projects.types.resolveType("void"));
      substance.addMethod(m); 
   }

   void addMethodFigure(MethodFigure f) {
      //MethodFigureFigure methodFigure = new MethodFigureFigure();
      methodFigures.add(f);
   }

   void addFieldFigure(FieldFigure f) {
      //MethodFigureFigure methodFigure = new MethodFigureFigure();
      fieldFigures.add(f);
   }

   public Vector getMethodFigures() {
      return methodFigures;
   }

   public String getName() {
      return ((TextFigure)figures().nextFigure()).getText();
   }

   public Vector getFieldFigures() {
      return fieldFigures;
   }

   public Vector getSuperClasses() {
      Vector result = new Vector();
      return result;
   }
   
   public Vector getInterfaces() {
      Vector result = new Vector();
      return result;
   }

   void initName() {
      ClassNameFigure name=new ClassNameFigure();
      name.setZValue(1);
      name.setText("NewClass");
      add(name);
   }

   Vector getClassFigures() {
      Vector ret = new Vector();
      ret.add(figures().nextFigure());
      ret.addAll(methodFigures);
      ret.addAll(fieldFigures);
      return ret;
   }

   private void initialize() {
      
      fDisplayBox = new Rectangle(0, 0, 0, 0);
      
      Font f = new Font("Helvetica", Font.PLAIN, 12);
      Font fb = new Font("Helvetica", Font.BOLD, 12);
      
      initName();
      setZValue(2);

   }
   
   public void layout() {
      Point partOrigin = new Point(fDisplayBox.x, fDisplayBox.y);
      partOrigin.translate(BORDER, BORDER);
      Dimension extent = new Dimension(0, 0);
      
      Iterator it = getClassFigures().iterator();
      
      while(it.hasNext()) {
         Figure f = (Figure)it.next();
         
         Dimension partExtent = f.size();
         Point corner = new Point(
            partOrigin.x+partExtent.width,
            partOrigin.y+partExtent.height);
         f.basicDisplayBox(partOrigin, corner);
         
         extent.width = Math.max(extent.width, partExtent.width);
         extent.height += partExtent.height;
         partOrigin.y += partExtent.height;
      }
      fDisplayBox.width = extent.width + 2*BORDER;
      fDisplayBox.height = extent.height + 2*BORDER;
   }

	private boolean needsLayout() {
           /*		Dimension extent = new Dimension(0, 0);

		FigureEnumeration k = figures();
		while (k.hasMoreElements()) {
			Figure f = k.nextFigure();
			extent.width = Math.max(extent.width, f.size().width);
		}
		int newExtent = extent.width + 2*BORDER;
		return newExtent != fDisplayBox.width;*/
           return true;
	}

	public void update(FigureChangeEvent e) {
           /*if (e.getFigure() == figureAt(1)) {
			// duration has changed
                   //updateDurations();
                   }*/
           if (needsLayout()) {
              layout();
              changed();
           }
	}

	public void figureChanged(FigureChangeEvent e) {
		update(e);
	}


	public void figureRemoved(FigureChangeEvent e) {
		update(e);
	}

   /*	public void notifyPostTasks() {
		Enumeration i = fPostTasks.elements();
		while (i.hasMoreElements()) {
			((PertFigure) i.nextElement()).updateDurations();
		}
	}

	public void updateDurations() {
		int newEnd = start()+duration();
		if (newEnd != end()) {
			setEnd(newEnd);
			notifyPostTasks();
		}
	}

	public boolean hasCycle(Figure start) {
		if (start == this) {
			return true;
		}
		Enumeration i = fPreTasks.elements();
		while (i.hasMoreElements()) {
			if (((PertFigure) i.nextElement()).hasCycle(start)) {
				return true;
			}
		}
		return false;
                }*/

	//-- store / load ----------------------------------------------

	public void write(StorableOutput dw) {
           //super.write(dw);
		dw.writeInt(fDisplayBox.x);
		dw.writeInt(fDisplayBox.y);
		dw.writeInt(fDisplayBox.width);
		dw.writeInt(fDisplayBox.height);

                dw.writeString(NameRepository.get().getName(substance));
                dw.writeString(NameRepository.get().getName(containerPackage));
                

	}

	public void read(StorableInput dr) throws IOException {
           //super.read(dr);
		fDisplayBox = new Rectangle(
			dr.readInt(),
			dr.readInt(),
			dr.readInt(),
			dr.readInt());

                try {
                   String name = dr.readString();
                   substance = (jac.ide.Class)NameRepository.get().getObject(name);

                   name = dr.readString();
                   containerPackage = (jac.ide.Package)NameRepository.get().getObject(name);

                   initClass();


                   /*                   int size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      MethodFigure m = (MethodFigure)dr.readStorable();
                      if( m.getSustance() == null ) {
                         m.removeFigure( m );
                      } else {
                         addMethodFigure( m );
                      }
                   }
                   size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      addFieldFigure((FieldFigure)dr.readStorable());
                   }
                   size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      addRelationLinkFigure((RelationLinkFigure)dr.readStorable());
                      }*/
                } catch(Exception e) {
                   e.printStackTrace();
                }
		layout();

	}
}
