
package jac.ide.diagrams;

import java.awt.*;
import java.util.*;
import java.io.*;
import javax.swing.JPanel;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.applet.*;
import javax.swing.*;
import javax.swing.event.EventListenerList;
import java.awt.event.*;
import java.util.*;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.applet.Applet;
import java.applet.AudioClip;
import java.net.URL;
import jac.core.Display;
import jac.core.Jac;
import jac.core.rtti.CollectionItem;
import jac.core.rtti.ClassRepository;
import jac.aspects.gui.CustomizedGUI;

public class DiagramView extends DiagramApplet implements ComponentListener {

   public static boolean init = false;

   private final static String PERTIMAGES = "/CH/ifa/draw/samples/pert/images/";
   static private final String JACIMAGES = Jac.getJacRoot()+"src/jac/ide/images/diagram/";
   Object substance;
   Container parent;

   public static Display display;
   public static Vector diagramViews = new Vector();

   public DiagramView(Display display, Container parent, Object substance) {
      super(substance);
      //setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
      //      DrawApplet applet = new DiagramApplet();
      //add(applet);
      this.substance = substance;
      this.parent = parent;
      DiagramView.display = display;
      diagramViews.add(this);
      init();
      start();
   }

   public static void refreshFigure(Figure f) {
      Iterator it = diagramViews.iterator();
      Vector fs = new Vector();
      fs.add(f);
      while(it.hasNext()) {
         DiagramView v = (DiagramView)it.next();
         v.view().draw(v.view().getGraphics(),
                       new FigureEnumerator(fs));
      }
   }

   public void init() {
      setStub(new InternalStub(new InternalContext(),this));
      super.init();
      parent.addComponentListener(this);
      //setSize(1000,1000);
   }

   public void componentHidden(ComponentEvent e) {
      System.out.println("--- HIDDEN "+e);
   }
   public void componentMoved(ComponentEvent e) {
      System.out.println("--- MOVED "+e);
   }      

   public void componentResized(ComponentEvent e) {
      System.out.println("--- RESIZED "+e);
      resize(e.getComponent().getWidth(),e.getComponent().getHeight());
      //getContentPane().resize(e.getComponent().getWidth(),e.getComponent().getHeight());
      validate();
   }
   public void componentShown(ComponentEvent e) {
      System.out.println("--- SHOWN "+e);
   }

   public void figureSelectionChanged(DrawingView view) {
      if( view.selection().size() > 0 ) {
         Figure f = (Figure)view.selection().get(0);

         if( f instanceof ClassFigure ) {
            CollectionItem coll = ClassRepository.get().getClass(jac.ide.Package.class)
               .getCollection("classes");
            ((CustomizedGUI)display).onSelection(coll,((ClassFigure)f).getSubstance(),null,null);

         } else if ( f instanceof InstanceFigure ) {

            CollectionItem coll = ClassRepository.get().getClass(jac.ide.Package.class)
               .getCollection("instances");
            ((CustomizedGUI)display).onSelection(coll,((InstanceFigure)f).getSubstance(),null,null);

         } else if ( f instanceof jac.ide.diagrams.RelationLinkFigure ) {
            
            jac.ide.RelationLink rel = (jac.ide.RelationLink)
               ((jac.ide.diagrams.RelationLinkFigure)f).getSubstance();
            jac.ide.Class cl = (jac.ide.Class)rel.getStart();
            CollectionItem coll = ClassRepository.get().getClass(jac.ide.Package.class)
               .getCollection("classes");
            ((CustomizedGUI)display).onSelection(coll,cl,null,null);
            coll = ClassRepository.get().getClass(jac.ide.Class.class)
               .getCollection("relationLinks");
            ((CustomizedGUI)display).onSelection(coll,rel,null,null);
            ((RelationLinkFigure)f).selectAll(view);

         } else if ( f instanceof PointcutLinkFigure ) {
            
            jac.ide.PointcutLink rel = (jac.ide.PointcutLink)
               ((PointcutLinkFigure)f).getSubstance();
            jac.ide.Aspect aspect = (jac.ide.Aspect)rel.getStart();
            CollectionItem coll = ClassRepository.get().getClass(jac.ide.Package.class)
               .getCollection("aspects");
            ((CustomizedGUI)display).onSelection(coll,aspect,null,null);
            coll = ClassRepository.get().getClass(jac.ide.Aspect.class)
               .getCollection("pointcutLinks");
            ((CustomizedGUI)display).onSelection(coll,rel,null,null);
            ((PointcutLinkFigure)f).selectAll(view);
         }
      }
   }

   protected void createTools(JPanel palette) {
      super.createTools(palette);
      
      Tool tool = new TextTool(this, new TextFigure());
      palette.add(createToolButton(IMAGES + "TEXT", "Text Tool", tool));
      
      tool = new NewClassFigureCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "class", "Create a new class", tool));

      tool = new ClassFigureCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "import", "Add an existing class", tool));

      tool = new NewAspectFigureCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "class", "Create a new aspect", tool));

      tool = new AspectFigureCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "import", "Add an existing aspect", tool));
      
      tool = new RelationLinkShowTool(this);
      palette.add(createToolButton(JACIMAGES + "see", "Show existing relation", tool));

      tool = new RelationLinkCreationTool(this, new RelationLinkFigure());
      palette.add(createToolButton(JACIMAGES + "relation", "New relation link", tool));

      tool = new AggregationCreationTool(this, new RelationLinkFigure());
      palette.add(createToolButton(JACIMAGES + "aggregation", "Aggregation link", tool));

      tool = new ConnectionTool(this, new RelationLinkFigure());
      palette.add(createToolButton(JACIMAGES + "addPoint", "Add a point", tool));

      tool = new UndoableTool(new AttachedTextTool(this, AttachedTextFigure.createEndCardinality()));
      palette.add(createToolButton(JACIMAGES + "relationCard", "Relation cardinality", tool));
      
            tool = new ConnectionTool(this, new InheritanceLinkFigure());
      palette.add(createToolButton(JACIMAGES + "inheritancelink", "Inheritance link", tool));      
      tool = new FieldCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "attribute", "Create new attribute", tool));
      
      tool = new MethodCreationTool(this);
      palette.add(createToolButton(JACIMAGES + "method", "Create new method", tool));
   }


   class InternalStub implements AppletStub {
      InternalContext context;
      Applet applet;
      public InternalStub(InternalContext context,Applet applet) {
         this.context=context;
         this.applet=applet;
         context.setApplet(applet);
      }
      public void appletResize(int width, int height) {
         System.out.println("*** resizing applet ***");
         //applet.setSize(width,height);
      }
      public AppletContext getAppletContext() {
         return context;
      }
      public URL getCodeBase() {
         URL ret = null;
         try {
         ret = new URL("file:/");
         } catch(Exception e) {
            e.printStackTrace();
         }
         return ret;
      }
      public URL getDocumentBase() {
         URL ret = null;
         try {
         ret = new URL("file:/");
         } catch(Exception e) {
            e.printStackTrace();
         }
         return ret;
      }
      public String getParameter(String name) {
         return null;
      }
      public boolean isActive() {
         return true;
      }
   }

   class InternalContext implements AppletContext {
      public void setApplet(Applet a) {
         v.add(a);
      }
      Vector v=new Vector();
      public Applet getApplet(String name) {
         return (Applet)v.get(0);
      }
      public Enumeration getApplets() {
         return v.elements();
      }
      public AudioClip getAudioClip(URL url) {
         return null;
      }
      public Image getImage(URL url) {
         return null;
      }
      public void showDocument(URL url) {
      }
      public void showDocument(URL url, String target) {
      }
      public void showStatus(String status) {
      }
   }


}
