
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

import jac.ide.Field;
import jac.ide.Class;
import jac.ide.Type;

public class FieldFigure extends TextFigure implements ModelElementFigure {

   Field substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public Field getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(Field  v) {
      this.substance = v;
   }
   
   public void linkToField(Class cl) {
      substance = cl.findField(getName());
   }

   public String getType() {
      String text = getText();
      int sep = text.indexOf(':');
      if(sep == -1) {
         return "";
      } else {
         return text.substring(sep+1);
      }      
   }
   
   public String getName() {
      String text = getText();
      int sep = text.indexOf(':');
      if(sep == -1) {
         return text;
      } else {
         return text.substring(0,sep);
      }      
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null && !DiagramView.init) {
         substance.setName(getName());
         substance.setType(jac.ide.Projects.types.resolveType(getType()));
      }
   }

}
