
package jac.ide.diagrams;

import java.awt.*;
import java.util.*;
import java.io.IOException;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.standard.*;

public class InheritanceLinkFigure extends ElbowConnection  {
   /*
    * Serialization support.
    */
   private static final long serialVersionUID = -7959500008698525009L;
   private int pertDependencySerializedDataVersion = 1;
      
   public InheritanceLinkFigure() {
      ArrowTip arrow = new ArrowTip(0.50, 25, 21);
      arrow.setFillColor(Color.white);
      setEndDecoration(arrow);
      setStartDecoration(null);
   }

   public void handleConnect(Figure start, Figure end) {
      ClassFigure source = (ClassFigure)start;
      ClassFigure target = (ClassFigure)end;
      source.addInheritanceLinkFigure(this);
      if( source.getSubstance() != null && target.getSubstance() != null ) {
         ((jac.ide.Class)source.getSubstance())
            .setSuperClass((jac.ide.Class)target.getSubstance());
      }
   }
   
   public void handleDisconnect(Figure start, Figure end) {
      if( start==null || end==null) return;
      ClassFigure source = (ClassFigure)start;
      ClassFigure target = (ClassFigure)end;
      source.removeInheritanceLinkFigure(this);
      if( source.getSubstance() != null ) {
         ((jac.ide.Class)source.getSubstance()).setSuperClass(null);
      }
   }
   
   public boolean canConnect(Figure start, Figure end) {
      return ((start instanceof ClassFigure) && (end instanceof ClassFigure));
   }
   
   public Vector handles() {
      Vector handles = super.handles();
      // don't allow to reconnect the starting figure
      handles.setElementAt(new NullHandle(this, PolyLineFigure.locator(0)), 0);
      return handles;
   }
}
