
package jac.ide.diagrams;

import java.awt.*;
import java.util.*;
import java.io.*;
import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.*;
import jac.core.NameRepository;
import jac.core.Wrappee;
import jac.aspects.gui.View;
import jac.util.Log;

public class InstanceFigure extends CompositeFigure implements View {
   private static final int BORDER = 3;
   private Rectangle fDisplayBox;
   
   jac.ide.Instance substance;
   
   // View interface
   public View getParentView() {
      return null;
   }

   public void refreshViewItem(jac.core.rtti.FieldItem field,
                               jac.core.rtti.MethodItem method, Object[] args) {
      refreshView();
   }

   public void setFocus(jac.core.rtti.FieldItem field, Object extraOption) {}

   public void refreshView() {
      if( DiagramView.init ) return;
      DiagramView.init = true;
      initInstance();
      layout();
      changed();
      DiagramView.refreshFigure(this);
      //editor().validate();
      DiagramView.init = false;
   }

   public void close() {}

   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public Object getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(jac.ide.Instance  v) {
      this.substance = v;
   }
   
   /*
    * Serialization support.
    */
   private static final long serialVersionUID = -7877776240236946511L;
   private int pertFigureSerializedDataVersion = 1;
   
   public InstanceFigure() {
      initialize();
   }

   /*boolean isInternal() {
      return containerPackage.getClasses().contains(substance);
      }*/

   jac.ide.Package containerPackage;
   
   /**
    * Get the value of containerPackage.
    * @return value of containerPackage.
    */
   public jac.ide.Package getContainerPackage() {
      return containerPackage;
   }
   
   /**
    * Set the value of containerPackage.
    * @param v  Value to assign to containerPackage.
    */
   public void setContainerPackage(jac.ide.Package  v) {
      this.containerPackage = v;
   }
      
   void initInstance() {
      if( substance == null ) {
         System.out.println("UNRESOLVED INSTANCE!");
      } else {
         Log.trace("figures","init class "+substance);
         initTitle();
         ((Wrappee)substance).invokeRoleMethod("addView",new Object[]{this});
      }
   }

   void initTitle() {
      InstanceNameFigure nf = (InstanceNameFigure)figures().nextFigure(); 
      nf.setSubstance(substance);
      nf.setText(substance.toString());
   }

   protected void basicMoveBy(int x, int y) {
      fDisplayBox.translate(x, y);
      super.basicMoveBy(x, y);
   } 

   public Rectangle displayBox() {
      return new Rectangle(
         fDisplayBox.x,
         fDisplayBox.y,
         fDisplayBox.width,
         fDisplayBox.height);
   }

   public void basicDisplayBox(Point origin, Point corner) {
      fDisplayBox = new Rectangle(origin);
      fDisplayBox.add(corner);
      layout();
   }

   protected void drawBorder(Graphics g) {
      
      Rectangle r = displayBox();

      g.setColor(Color.white);

      g.fillRoundRect(r.x, r.y, r.width, r.height,7,7);
      
      g.setColor(Color.black);
      
      g.drawRoundRect(r.x, r.y, r.width, r.height,7,7);
      
      
      //Figure f = figureAt(0);
      //Rectangle rf = f.displayBox();
      
   }

   public void draw(Graphics g) {
      drawBorder(g);
      super.draw(g);
   }

   public Vector handles() {
      Vector handles = new Vector();
      handles.addElement(new NullHandle(this, RelativeLocator.northWest()));
      handles.addElement(new NullHandle(this, RelativeLocator.northEast()));
      handles.addElement(new NullHandle(this, RelativeLocator.southWest()));
      handles.addElement(new NullHandle(this, RelativeLocator.southEast()));
      return handles;
   }

   public String getName() {
      return ((TextFigure)figures().nextFigure()).getText();
   }

   void initName() {
      InstanceNameFigure name=new InstanceNameFigure();
      name.setText("NewInstance");
      add(name);
   }

   private void initialize() {
      
      fDisplayBox = new Rectangle(0, 0, 0, 0);
      
      Font f = new Font("Helvetica", Font.PLAIN, 12);
      Font fb = new Font("Helvetica", Font.BOLD, 12);
      
      initName();

   }
   
   public void layout() {
      Point partOrigin = new Point(fDisplayBox.x, fDisplayBox.y);
      partOrigin.translate(BORDER, BORDER);
      Dimension extent = new Dimension(0, 0);


      Dimension partExtent = figureAt(0).size();
      Point corner = new Point(
         partOrigin.x+partExtent.width,
         partOrigin.y+partExtent.height);
      figureAt(0).basicDisplayBox(partOrigin, corner);
         
      extent.width = partExtent.width;
      extent.height = partExtent.height;
      fDisplayBox.width = extent.width + 2*BORDER;
      fDisplayBox.height = extent.height + 2*BORDER;

   }

	private boolean needsLayout() {
           /*		Dimension extent = new Dimension(0, 0);

		FigureEnumeration k = figures();
		while (k.hasMoreElements()) {
			Figure f = k.nextFigure();
			extent.width = Math.max(extent.width, f.size().width);
		}
		int newExtent = extent.width + 2*BORDER;
		return newExtent != fDisplayBox.width;*/
           return true;
	}

	public void update(FigureChangeEvent e) {
           /*if (e.getFigure() == figureAt(1)) {
			// duration has changed
                   //updateDurations();
                   }*/
           if (needsLayout()) {
              layout();
              changed();
           }
	}

	public void figureChanged(FigureChangeEvent e) {
		update(e);
	}


	public void figureRemoved(FigureChangeEvent e) {
		update(e);
	}

   /*	public void notifyPostTasks() {
		Enumeration i = fPostTasks.elements();
		while (i.hasMoreElements()) {
			((PertFigure) i.nextElement()).updateDurations();
		}
	}

	public void updateDurations() {
		int newEnd = start()+duration();
		if (newEnd != end()) {
			setEnd(newEnd);
			notifyPostTasks();
		}
	}

	public boolean hasCycle(Figure start) {
		if (start == this) {
			return true;
		}
		Enumeration i = fPreTasks.elements();
		while (i.hasMoreElements()) {
			if (((PertFigure) i.nextElement()).hasCycle(start)) {
				return true;
			}
		}
		return false;
                }*/

	//-- store / load ----------------------------------------------

	public void write(StorableOutput dw) {
		super.write(dw);
		dw.writeInt(fDisplayBox.x);
		dw.writeInt(fDisplayBox.y);
		dw.writeInt(fDisplayBox.width);
		dw.writeInt(fDisplayBox.height);

                dw.writeString(NameRepository.get().getName(substance));
                dw.writeString(NameRepository.get().getName(containerPackage));
                

	}

	public void read(StorableInput dr) throws IOException {
		super.read(dr);
		fDisplayBox = new Rectangle(
			dr.readInt(),
			dr.readInt(),
			dr.readInt(),
			dr.readInt());

                try {
                   String name = dr.readString();
                   substance = (jac.ide.Instance)NameRepository.get().getObject(name);

                   name = dr.readString();
                   containerPackage = (jac.ide.Package)NameRepository.get().getObject(name);

                   initInstance();


                   /*                   int size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      MethodFigure m = (MethodFigure)dr.readStorable();
                      if( m.getSustance() == null ) {
                         m.removeFigure( m );
                      } else {
                         addMethodFigure( m );
                      }
                   }
                   size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      addFieldFigure((FieldFigure)dr.readStorable());
                   }
                   size = dr.readInt();
                   for (int i=0; i<size; i++) {
                      addRelationLinkFigure((RelationLinkFigure)dr.readStorable());
                      }*/
                } catch(Exception e) {
                   e.printStackTrace();
                }
		layout();

	}
}
