
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

import java.util.Vector;
import java.util.Iterator;
import java.util.StringTokenizer;

public class MethodFigure extends TextFigure implements ModelElementFigure {

   jac.ide.Method substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public jac.ide.Method getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(jac.ide.Method  v) {
      this.substance = v;
   }
   
   public String getPrototype() {
      String text = getText();
      int sep = text.indexOf(':');
      if(sep == -1) {
         return "void "+text;
      } else {
         return text.substring(sep+1)+" "+text.substring(0,sep);
      }      
   }

   public String getType() {
      String text = getText();
      int sep = text.indexOf(':');
      if(sep == -1) {
         return "";
      } else {
         return text.substring(sep+1);
      }      
   }
   
   public String getName() {
      String text = getText();
      int sep = text.indexOf('(');
      if(sep == -1) {
         return text;
      } else {
         return text.substring(0,sep);
      }      
   }

   public Vector getArgs() {
      Vector result = new Vector();
      String text = getText();
      String args = text.substring(text.indexOf('(')+1);
      args = args.substring(0,args.indexOf(')'));
      StringTokenizer st = new StringTokenizer(args,",");
      while (st.hasMoreTokens()) {
         String s = st.nextToken();
         s=s.trim();
         String type = s.substring(0,s.indexOf(' '));
         String name = s.substring(s.indexOf(' ')+1);
         System.out.println("parameter: "+type+" "+name);
         result.add(new String[]{name,type});
      }
      return result;
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null && !DiagramView.init ) {
         System.out.println("name: "+getName());
         substance.setName(getName());
         System.out.println("type: "+getType());
         substance.setType(jac.ide.Projects.types.resolveType(getType()));
         Iterator it = ((jac.lib.java.util.Vector)substance.getParameters().clone()).iterator();
         while(it.hasNext()) {
            substance.getParameters().remove(it.next());
         }
         it = getArgs().iterator();
         while(it.hasNext()) {
            String[] param = (String[])it.next();
            jac.ide.Parameter parameter = new jac.ide.Parameter();
            parameter.setName(param[0]);
            parameter.setType(jac.ide.Projects.types.resolveType(param[1]));
            substance.addParameter(parameter);
         }
      }
   }

}
