
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import jac.ide.PointcutRelationLink;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

public class PCDFigure extends TextFigure {

   PointcutRelationLink substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public PointcutRelationLink getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(PointcutRelationLink  v) {
      this.substance = v;
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null ) {
         int index = s.indexOf(":");
         if( index != -1 ) {
            substance.setMethodPCD(s.substring(0,index));
            substance.setHostPCD(s.substring(index+1));
         } else {
            substance.setMethodPCD(s);
         }
      }
   }

   //-- store / load ----------------------------------------------
   
   public void write(StorableOutput dw) {
      super.write(dw);
      
      dw.writeString(NameRepository.get().getName(substance));
            
   }
   
   public void read(StorableInput dr) throws IOException {
      super.read(dr);
      
      try {
         String name = dr.readString();
         substance = (jac.ide.PointcutRelationLink)NameRepository.get().getObject(name);
      } catch(Exception e) {
         e.printStackTrace();
      }
      
   }

}
