package jac.ide.diagrams;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.Geom;
import CH.ifa.draw.util.UndoableAdapter;
import CH.ifa.draw.util.Undoable;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.*;
import jac.util.Log;
import jac.core.rtti.ClassRepository;


public class PointcutLinkShowTool extends ActionTool {

   public PointcutLinkShowTool(DrawingEditor newDrawingEditor) {
      super(newDrawingEditor);
   }

   // gui related infos and methods

   static jac.ide.Aspect curAspect=null;

   public static jac.lib.java.util.Vector pointcuts(Object o) {
      if(curAspect!=null) {
         return curAspect.getPointcutLinks();
      } else {
         return null;
      }
   }

   public void choosePointcut(jac.ide.PointcutLink pointcut) {
   }

   public void action(Figure figure) {
      if(! (figure instanceof AspectFigure) ) return;
      
      curAspect=(jac.ide.Aspect)((AspectFigure)figure).getSubstance();
      Object[] parameters = new Object[] {null};
      boolean result = DiagramView.display.showInput(
         this,ClassRepository.get().getClass(getClass()).getMethod("choosePointcut"),
         parameters);
      Figure cf = null;
      if( result ) {
         jac.ide.PointcutLink rel = (jac.ide.PointcutLink)parameters[0];
         if( rel == null || rel.getEnd() == null ) return;
         
         if( rel.getEnd() instanceof jac.ide.TypedElement ) {
            cf = ((DiagramView)editor()).findElement((jac.ide.TypedElement)rel.getEnd());
         }
         if( cf == null ) {
            // end is not found in the diagram... import it!
            DiagramView.display.showMessage("You must import '"+
                                            rel.getEnd()+
                                            "' before this action.",
                                            "Error",false,false,true);
         } else {

            PointcutLinkFigure relf = new PointcutLinkFigure();
            relf.startPoint(figure.center().x,figure.center().y);
            relf.endPoint(cf.center().x,cf.center().y);
            relf.connectStart(figure.connectorAt(figure.center().x,figure.center().y));
            relf.connectEnd(cf.connectorAt(cf.center().x,cf.center().y));

            relf.setSubstance(rel);

            view().add(relf);

            view().add(relf.createAttachedFigure(
               AttachedTextFigure.NAME));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.START_ROLE));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.END_ROLE));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.START_CARDINALITY));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.END_CARDINALITY));
            
            relf.updateConnection();
            ((jac.core.Wrappee)rel).invokeRoleMethod("addView",new Object[]{relf});

            editor().toolDone();
         }
      }
   }

}

