
package jac.ide.diagrams;

import CH.ifa.draw.figures.*;
import jac.ide.RelationLink;
import CH.ifa.draw.util.StorableInput;
import CH.ifa.draw.util.StorableOutput;
import java.io.IOException;
import jac.core.NameRepository;

public class RelationCardinalityFigure extends TextFigure {

   RelationLink substance;
   
   /**
    * Get the value of substance.
    * @return value of substance.
    */
   public RelationLink getSubstance() {
      return substance;
   }
   
   /**
    * Set the value of substance.
    * @param v  Value to assign to substance.
    */
   public void setSubstance(RelationLink  v) {
      this.substance = v;
   }

   public void setText(String s) {
      super.setText(s);
      if( substance != null ) {
         substance.setEndCardinality(s);
      }
   }

   //-- store / load ----------------------------------------------
   
   public void write(StorableOutput dw) {
      super.write(dw);
      
      dw.writeString(NameRepository.get().getName(substance));
            
   }
   
   public void read(StorableInput dr) throws IOException {
      super.read(dr);
      
      try {
         String name = dr.readString();
         substance = (jac.ide.RelationLink)NameRepository.get().getObject(name);
      } catch(Exception e) {
         e.printStackTrace();
      }
      
   }

}
