package jac.ide.diagrams;

import CH.ifa.draw.framework.*;
import CH.ifa.draw.standard.*;
import CH.ifa.draw.figures.*;
import CH.ifa.draw.util.Geom;
import CH.ifa.draw.util.UndoableAdapter;
import CH.ifa.draw.util.Undoable;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.util.*;
import jac.util.Log;
import jac.core.rtti.ClassRepository;


public class RelationLinkShowTool extends ActionTool {

   public RelationLinkShowTool(DrawingEditor newDrawingEditor) {
      super(newDrawingEditor);
   }

   // gui related infos and methods

   static jac.ide.Class curClass=null;

   public static jac.lib.java.util.Vector relations(Object o) {
      if(curClass!=null) {
         return curClass.getRelationLinks();
      } else {
         return null;
      }
   }

   public void chooseRelation(jac.ide.RelationLink relation) {
   }

   public void action(Figure figure) {
      if(! (figure instanceof ClassFigure) ) return;
      
      curClass=(jac.ide.Class)((ClassFigure)figure).getSubstance();
      Object[] parameters = new Object[] {null};
      boolean result = DiagramView.display.showInput(
         this,ClassRepository.get().getClass(getClass()).getMethod("chooseRelation"),
         parameters);
      ClassFigure cf = null;
      if( result ) {
         jac.ide.RelationLink rel = (jac.ide.RelationLink)parameters[0];
         if( rel == null || rel.getEnd() == null ) return;
         
         cf = ((DiagramView)editor()).findClass((jac.ide.Class)rel.getEnd());
         if( cf == null ) {
            // class is not foud in the diagram... import it!
            DiagramView.display.showMessage("You must import class '"+
                                            (jac.ide.Class)rel.getEnd()+
                                            "' before this action.",
                                            "Error",false,false,true);
         } else {

            RelationLinkFigure relf = new RelationLinkFigure();
            relf.startPoint(figure.center().x,figure.center().y);
            relf.endPoint(cf.center().x,cf.center().y);
            relf.connectStart(figure.connectorAt(figure.center().x,figure.center().y));
            relf.connectEnd(cf.connectorAt(cf.center().x,cf.center().y));

            relf.setSubstance(rel);

            if( rel.isAggregation() ) {
               Log.trace("figures","creating aggregation arrow");
               ArrowTip arrow = new ArrowTip(0.50, 15, 28);
               arrow.setFillColor(Color.white);
               relf.setStartDecoration(arrow);
            }

            view().add(relf);

            view().add(relf.createAttachedFigure(
               AttachedTextFigure.NAME));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.START_ROLE));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.END_ROLE));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.START_CARDINALITY));
            view().add(relf.createAttachedFigure(
               AttachedTextFigure.END_CARDINALITY));

            /*AttachedTextFigure name = AttachedTextFigure.createName();
            name.setText(rel.getName());
            name.setSubstance(rel);
            name.connect(relf);
            view().add(name);

            if( rel.getEndCardinality()!=null && !rel.getEndCardinality().equals("")) {
               AttachedTextFigure card = AttachedTextFigure.createEndCardinality();
               card.setText(rel.getEndCardinality());
               card.setSubstance(rel);
               card.connect(relf);
               view().add(card);
               }*/
            
            relf.updateConnection();
            ((jac.core.Wrappee)rel).invokeRoleMethod("addView",new Object[]{relf});

            editor().toolDone();
         }
      }
   }

}

