/*
 * @(#)CopyCommand.java
 *
 * Project:		JHotdraw - a GUI framework for technical drawings
 *				http://www.jhotdraw.org
 *				http://jhotdraw.sourceforge.net
 * Copyright:	 by the original author(s) and all contributors
 * License:		Lesser GNU Public License (LGPL)
 *				http://www.opensource.org/licenses/lgpl-license.html
 */

package jac.ide.diagrams;

import java.util.*;
import CH.ifa.draw.util.*;
import CH.ifa.draw.applet.*;
import CH.ifa.draw.standard.AbstractCommand;
import CH.ifa.draw.framework.*;

public class SaveCommand extends AbstractCommand {

	/**
	 * Constructs a copy command.
	 * @param name the command name
	 * @param newDrawingEditor the DrawingEditor which manages the views
	 */
	public SaveCommand(String name, DrawingEditor newDrawingEditor) {
		super(name,newDrawingEditor);
	}

	public void execute() {
		super.execute();
                ((DiagramApplet)getDrawingEditor()).save();
		//copyFigures(view().selectionElements(), view().selectionCount());
	}

	protected boolean isExecutableWithView() {
		return true;
	}
}
