/*

  Copyright (C) AOPSYS (http://www.aopsys.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

package jac.samples.photos;

import jac.lib.java.util.HashSet;
import java.util.Set;

public class Person {
   String name;

   public Person(String name) {
      this.name = name;
   }
   
   /**
    * Get the value of name.
    * @return value of name.
    */
   public String getName() {
      return name;
   }
   
   /**
    * Set the value of name.
    * @param name  Value to assign to name.
    */
   public void setName(String  name) {
      this.name = name;
   }
   
   boolean pro;
   
   /**
    * Get the value of pro.
    * @return value of pro.
    */
   public boolean isPro() {
      return pro;
   }
   
   /**
    * Set the value of pro.
    * @param v  Value to assign to pro.
    */
   public void setPro(boolean  v) {
      this.pro = v;
   }
   

   HashSet photos = new HashSet();

   public Set getPhotos() {
      return photos;
   }

   public void addPhoto(Photo photo) {
      photos.add(photo);
   }

   public void removePhoto(Photo photo) {
      photos.remove(photo);
   }

   public String toString() {
      if (name!=null)
         return name;
      else 
         return super.toString();
   }
}
