/*
  Copyright (C) AOPSYS (http://www.aopsys.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

package jac.samples.photos;

import java.awt.*;
import java.util.Date;
import java.net.URL;

public class Photo {

   protected String title = "";
   protected Date date;
   protected URL imageURL = null;
   protected int rate = 5;
   
   Person author;
      
   /**
    * Get the value of Author.
    * @return value of Author.
    */
   public Person getAuthor() {
      return author;
   }
      
   /**
    * Set the value of Author.
    * @param author  Value to assign to Author.
    */
   public void setAuthor(Person  author) {
      this.author = author;
   }
   
   public Photo ( ) {  
      title = "untitled";
      date = new Date();
      imageURL = null;
   }
   
   public Photo ( String title, URL imageURL ) {
      this.title = title;
      this.imageURL = imageURL;
      this.date = new Date();
   }
   
   public void setImageURL(URL imageURL) {
      this.imageURL = imageURL;      
   }

   public URL getImageURL() {
      return imageURL;
   }

   public String getTitle() {
      return title;
   }
    
   public void setTitle( String title ) {
      this.title = title;      
   }

   /**
    * Get the value of date.
    * @return value of date.
    */
   public Date getDate() {
      return date;
   }
    
   /**
    * Set the value of date.
    * @param v  Value to assign to date.
    */
   public void setDate(Date  v) {
      this.date = v;
   }
    
   public int getRate() {
      return rate;
   }

   public void setRate(int rate) {
      this.rate = rate;
   }

   public String toString() {
      return getTitle()+"["+getAuthor()+"]";
   }

/*
 public java.io.Reader print() {
      String template = "Title:%title%<br>Author: %author%<br>Date: %date%<br>Rate : %rate%";
      java.util.Hashtable params = new java.util.Hashtable();
      params.put("title",getTitle());
      if (author!=null) {
         params.put("author",getAuthor().getName());
      } else {
         params.put("author","non communiqu");
      }
      params.put("date",getDate().toString());
      params.put("rate",new Integer(getRate()));
      java.io.Reader file;
      try {
         file = new java.io.InputStreamReader(new java.io.FileInputStream("photo.abw"),
                                              "UTF-8");
         return new jac.aspects.gui.TemplateReader(file,params);
      } catch(Exception e) {
         e.printStackTrace();
         return null;
      }
      //      return new jac.aspects.gui.TemplateReader(new java.io.StringReader(template),params);
   }
 */
}
