package jac.util;

import java.io.FilterWriter;
import java.io.Writer;
import java.io.IOException;

public class LineNumberWriter extends FilterWriter
{
   // last read byte
   int last = -1;
   int lines = 1;

   public LineNumberWriter(Writer out) {
      super(out);
   }

   public void write(int b) throws IOException {
      System.out.println("write char"+b);
      if ( (b == '\r' && last != '\n') || 
           (b=='\n') ) {
         lines++;
      }
      out.write(b);
      last = b;
   }

   public void write(char[] b, int off, int len) throws IOException
   {
      System.out.println("write buf"+b);
      System.out.println("lines = "+lines);
      while (len-- > 0) {
         write(b[off++]);
      }
      System.out.println("lines = "+lines);
   }

   public void write(String str, int off, int len) throws IOException
   {
      System.out.println("write str"+str);
      System.out.println("lines = "+lines);
      while (len-- > 0) {
         write(str.charAt(off++));
      }
      System.out.println("lines = "+lines);
   }

   public int getLines() {
      return lines;
   }
}

